#include <stdio.h>
#include <stdlib.h>
#include "socket.h"
#include "channel.h"
#include <signal.h>

/*#define TRACE_ON*/
#include "debug.h"

#define XPORT	6000

static char  _Address[100];
static int  _Port;

void
VXUsage()
{
	fprintf(stderr, "PXhan [-display display] [command list...]\n");
	exit(0);
}

VXSetAddress(char *dname)
{
	int  i;

	if(dname == NULL) {
		fprintf(stderr, "DISPLAY is not set !!!\n");
		exit(0);
	}

	strcpy(_Address, dname);
	for(i = 0; i < strlen(dname); i++) {
		if(dname[i] == ':') {
			if(i == 0)
				gethostname(_Address, 100);
			else
				_Address[i] = '\0';
			_Port = XPORT + atoi(&dname[i+1]);
			fprintf(stderr, "SERVER = %s:%d\n", _Address, _Port-XPORT);
			return;
		}
	}

	VXUsage();
}

VXGetAddress(char *addr, int *port)
{
	strcpy(addr, _Address);
	*port = _Port;
}

int  VXLocalPort;
char  VXPortFile[100], VXHanFontName[100], VXASCFontName[100];



main(int argc, char **argv)
{
	int  port, arg_cmd;
	char  hostname[100], display[100], hostaddr[100], fname[20];
	char  *han_font, *asc_font;
	FILE  *fp;
	pid_t	pid1, pid2;
	char buf[100];

	if(argc >= 3 && strncmp(argv[1], "-disp", 5) == 0) {
		arg_cmd = 3;
		VXSetAddress(argv[2]);
	} else {
		arg_cmd = 1;
		VXSetAddress(getenv("DISPLAY"));
	}
	VXGetAddress(hostname, &port);
	sprintf(display, "%s:%d.0\n", hostname, port-XPORT);

	for(port = XPORT+1; (VXSockFD = SockInitializeServer(port)) < 0;port++);
	PXgethostname (hostname, 100);
	PXgethostaddr (hostname, hostaddr);
	fprintf(stderr, "new DISPLAY = %s:%d or %s:%d\n",
		hostname, port-XPORT, hostaddr, port-XPORT);

	VXLocalPort = port;

	sprintf(buf, "DISPLAY=%s:%d", hostname, port-XPORT);
	putenv(buf);

	if((han_font = getenv("PXHAN_HAN_FONT")) != NULL) {
		strcpy(VXHanFontName, han_font);
	} else {
		strcpy(VXHanFontName,
		"-kaist-iyagi-bold-r-normal--16-160-75-75-c-160-johabsh-1");
	}

	if((asc_font = getenv("PXHAN_ASC_FONT")) != NULL) {
		strcpy(VXASCFontName, asc_font);
	} else {
		strcpy(VXASCFontName,
		"-schumacher-clean-bold-r-normal--16-160-75-75-c-80-iso8859-1");
	}


	if (argc > arg_cmd)
	{
		pid1 = fork();
		if (pid1 == 0)
		{
			execvp(argv[arg_cmd], argv+arg_cmd);
			exit(1);
		}
		pid2 = fork();
		if (pid2 == 0)
		{
			VXInitChannel();
			VXMainLoop();
			exit(1);
		}
		wait(NULL);
		kill(pid1,SIGTERM);
		kill(pid2,SIGTERM);
	}
	else
	{
		VXInitChannel();
		VXMainLoop();
	}
}

